> For the complete documentation index, see [llms.txt](https://docs.frends.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.frends.com/reference/frends-platform-api/platform-api-reference/api-specifications.md).

# Api Specifications

## GET /api/v1/api-management/api-specifications

> List API specifications

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications":{"get":{"tags":["ApiSpecifications"],"summary":"List API specifications","operationId":"GetApiSpecifications","parameters":[{"name":"PageNumber","in":"query","description":"Current page number. Default value is 1.","schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"}},{"name":"PageSize","in":"query","description":"Maximum page size is 200. Default page size is 30.","schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PagedResponseOfDtoApiSpecification"}}}}}}}},"components":{"schemas":{"PagedResponseOfDtoApiSpecification":{"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/DtoApiSpecification"},"description":"Response data"},"paging":{"description":"Response paging","$ref":"#/components/schemas/PagingModel"}}},"DtoApiSpecification":{"required":["name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the API specification","format":"int64"},"name":{"type":"string","description":"Name of the API specification"},"activeVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Currently active version of the API specification","format":"int32"},"description":{"type":["null","string"],"description":"Description for the API specification"}}},"PagingModel":{"type":"object","properties":{"currentPage":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Current page","format":"int32"},"pageSize":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Number of entries per page","format":"int32"},"totalCount":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Total number of entries","format":"int32"},"firstPage":{"type":["null","string"],"description":"Url of the first page","format":"uri"},"lastPage":{"type":["null","string"],"description":"Url of the last page","format":"uri"},"nextPage":{"type":["null","string"],"description":"Url of the next page","format":"uri"},"previousPage":{"type":["null","string"],"description":"Url of the previous page","format":"uri"}}}}}}
```

## Create API specification

> The Base path (openAPI 2) / Server url (openAPI 3) cannot be modified later.

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications":{"post":{"tags":["ApiSpecifications"],"summary":"Create API specification","description":"The Base path (openAPI 2) / Server url (openAPI 3) cannot be modified later.","requestBody":{"description":"OpenAPI Specification in a stringified JSON or YAML format","content":{"application/json":{"schema":{"oneOf":[{"type":"null"},{"type":"string"}]}}}},"responses":{"201":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseOfDtoApiSpecification"}}}},"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"409":{"description":"Conflict","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ResponseOfDtoApiSpecification":{"required":["data"],"type":"object","properties":{"data":{"oneOf":[{"type":"null"},{"description":"Response data","$ref":"#/components/schemas/DtoApiSpecification"}]}}},"DtoApiSpecification":{"required":["name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the API specification","format":"int64"},"name":{"type":"string","description":"Name of the API specification"},"activeVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Currently active version of the API specification","format":"int32"},"description":{"type":["null","string"],"description":"Description for the API specification"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## Import API specification

> This can be a very slow action. Please make sure your client has a long enough timeout so that the operation does not get cancelled. This creates version 1 of the API specification to the default Agent group. The Base path (openAPI 2) / Server url (openAPI 3) cannot be modified later.

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/import":{"post":{"tags":["ApiSpecifications"],"summary":"Import API specification","description":"This can be a very slow action. Please make sure your client has a long enough timeout so that the operation does not get cancelled. This creates version 1 of the API specification to the default Agent group. The Base path (openAPI 2) / Server url (openAPI 3) cannot be modified later.","requestBody":{"content":{"multipart/form-data":{"schema":{"required":["file"],"type":"object","properties":{"file":{"type":"string","format":"binary"}},"description":"File to upload.","discriminator":{"propertyName":"ImportApiSpecification"}}}}},"responses":{"201":{"description":"Created","headers":{"Location":{"description":"Location of the created API specification","schema":{"type":"string"}}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseOfDtoApiSpecification"}}}},"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"409":{"description":"Conflict","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"415":{"description":"Unsupported Media Type","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ResponseOfDtoApiSpecification":{"required":["data"],"type":"object","properties":{"data":{"oneOf":[{"type":"null"},{"description":"Response data","$ref":"#/components/schemas/DtoApiSpecification"}]}}},"DtoApiSpecification":{"required":["name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the API specification","format":"int64"},"name":{"type":"string","description":"Name of the API specification"},"activeVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Currently active version of the API specification","format":"int32"},"description":{"type":["null","string"],"description":"Description for the API specification"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## GET /api/v1/api-management/api-specifications/{id}

> Get a single API specification

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{id}":{"get":{"tags":["ApiSpecifications"],"summary":"Get a single API specification","operationId":"SingleApiSpecification","parameters":[{"name":"id","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseOfDtoApiSpecification"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ResponseOfDtoApiSpecification":{"required":["data"],"type":"object","properties":{"data":{"oneOf":[{"type":"null"},{"description":"Response data","$ref":"#/components/schemas/DtoApiSpecification"}]}}},"DtoApiSpecification":{"required":["name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the API specification","format":"int64"},"name":{"type":"string","description":"Name of the API specification"},"activeVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Currently active version of the API specification","format":"int32"},"description":{"type":["null","string"],"description":"Description for the API specification"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## PUT /api/v1/api-management/api-specifications/{id}

> Update API specification

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{id}":{"put":{"tags":["ApiSpecifications"],"summary":"Update API specification","parameters":[{"name":"id","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"requestBody":{"description":"The new specification","content":{"application/json":{"schema":{"type":"string"}}},"required":true},"responses":{"200":{"description":"OK"},"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## GET /api/v1/api-management/api-specifications/{id}/{apiVersion}

> Get a specific version of an API specification

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{id}/{apiVersion}":{"get":{"tags":["ApiSpecifications"],"summary":"Get a specific version of an API specification","operationId":"GetApiVersion","parameters":[{"name":"id","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}},{"name":"apiVersion","in":"path","description":"API specification version","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int32"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseOfDtoApiSpecification"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ResponseOfDtoApiSpecification":{"required":["data"],"type":"object","properties":{"data":{"oneOf":[{"type":"null"},{"description":"Response data","$ref":"#/components/schemas/DtoApiSpecification"}]}}},"DtoApiSpecification":{"required":["name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier for the API specification","format":"int64"},"name":{"type":"string","description":"Name of the API specification"},"activeVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Currently active version of the API specification","format":"int32"},"description":{"type":["null","string"],"description":"Description for the API specification"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## Delete API specification from an Agent Group

> To delete a specification from the default Agent group, it must first be deleted from all other Agent groups. Deleting the API specification from the default Agent group deletes it permanently. Linked processes are not deleted.

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{apiSpecificationId}/agent-group/{agentGroupId}":{"delete":{"tags":["ApiSpecifications"],"summary":"Delete API specification from an Agent Group","description":"To delete a specification from the default Agent group, it must first be deleted from all other Agent groups. Deleting the API specification from the default Agent group deletes it permanently. Linked processes are not deleted.","parameters":[{"name":"apiSpecificationId","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}},{"name":"agentGroupId","in":"path","description":"Agent Group identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"responses":{"204":{"description":"No Content","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"409":{"description":"Conflict","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## POST /api/v1/api-management/api-specifications/{id}/{apiVersion}/processTemplate

> Get process template for a specific endpoint of an API specification

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{id}/{apiVersion}/processTemplate":{"post":{"tags":["ApiSpecifications"],"summary":"Get process template for a specific endpoint of an API specification","parameters":[{"name":"id","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}},{"name":"apiVersion","in":"path","description":"API specification version","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int32"}}],"requestBody":{"description":"Request which specifies the API endpoint","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiProcessTemplateRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseOfProcessDataModel"}}}},"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ApiProcessTemplateRequest":{"required":["path","operation"],"type":"object","properties":{"path":{"type":"string","description":"The path of the HTTP endpoint, as specified in the API specification"},"operation":{"type":"string","description":"The operation of the endpoint (e.g. GET)"}}},"ResponseOfProcessDataModel":{"required":["data"],"type":"object","properties":{"data":{"oneOf":[{"type":"null"},{"description":"Response data","$ref":"#/components/schemas/ProcessDataModel"}]}}},"ProcessDataModel":{"required":["name"],"type":"object","properties":{"bpmn":{"type":"string"},"elementParameters":{"type":"array","items":{"$ref":"#/components/schemas/ElementParameters"}},"manualTrigger":{"type":"array","items":{"type":"array","items":{}}},"obsoleteTasks":{"type":"array","items":{"$ref":"#/components/schemas/TaskSelectionData"}},"draftId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int64"},"idOfBaseProcessForDraft":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int64"},"isDraft":{"type":"boolean"},"isSubprocess":{"type":"boolean"},"triggerData":{"type":["null","array"],"items":{"type":"array","items":{}}},"majorVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"minorVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"activateIfNew":{"type":"boolean"},"frendsVersion":{"type":["null","string"]},"ignoreDependencyConflicts":{"type":["null","boolean"]},"documentationMarkdown":{"type":["null","string"]},"targetFramework":{"type":"string"},"apiSpecId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int64"},"isForMonitoringRule":{"type":"boolean"},"validationOnly":{"type":"boolean"},"cancellationDisabled":{"type":"boolean"},"preserveReferencesAtCheckpoint":{"type":"boolean"},"processVariables":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ProcessVariable"}},"processTemplateId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int64"},"processTemplateDeviated":{"type":["null","string"],"format":"date-time"},"nextProcessTemplate":{"oneOf":[{"type":"null"},{"$ref":"#/components/schemas/ProcessTemplate"}]},"performAdditionalSyntaxValidation":{"type":"boolean"},"isDeleted":{"type":"boolean"},"version":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"uniqueIdentifier":{"type":"string","format":"uuid"},"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"modified":{"type":"string","format":"date-time"},"modifier":{"type":["null","string"]},"description":{"type":["null","string"]},"isNotLatestVersion":{"type":"boolean"},"changeDescription":{"type":["null","string"]}}},"ElementParameters":{"type":"object","properties":{"id":{"type":["null","string"]},"type":{"$ref":"#/components/schemas/ElementType"},"parameters":{"type":["null","object"],"additionalProperties":{"type":"array","items":{"type":"array","items":{}}}},"selectedTypeId":{"type":["null","string"]},"promoteResultAs":{"type":["null","string"]},"name":{"type":["null","string"]},"description":{"type":["null","string"]},"isDefault":{"type":["null","boolean"]},"shouldRetry":{"type":["null","boolean"]},"maxRetryCount":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"shouldNotLogResult":{"type":["null","boolean"]},"shouldDispose":{"type":["null","boolean"]}}},"ElementType":{"enum":["Start","Task","Decision","SequenceFlow","ConditionBranch","Return","Throw","CallActivity","SubProcess","ParallelForeach","SequentialForeach","While","Expression","SubProcessStartNode","Catch","InclusiveGateway","InclusiveDecisionBranch","IntermediateReturn","GlobalErrorHandler","TestTask","SharedState","Dmn","DataObjectReference","DataStoreReference","HydrationPoint","ScheduledRehydration","SignalRehydration","NativeAi","Vdm"]},"TaskSelectionData":{"type":"object","properties":{"uri":{"type":"string"},"argumentsJson":{"type":["null","string"]},"returnType":{"type":["null","string"]},"name":{"type":"string"},"displayName":{"type":["null","string"]},"packageName":{"type":"string"},"description":{"type":["null","string"]},"isNotLatestVersion":{"type":"boolean"},"isStandard":{"type":"boolean"},"isDotNet":{"type":"boolean"}}},"ProcessVariable":{"type":"object","properties":{"name":{"type":["null","string"]},"value":{"type":["null","string"]},"isSecret":{"type":"boolean"},"mode":{"type":["null","string"]},"description":{"type":["null","string"]}}},"ProcessTemplate":{"required":["uniqueIdentifier","isListed","version","isDeleted","majorVersion","minorVersion","name","modifier","modified","targetFramework","frendsVersion","isSubProcess","staticRequiredEnvironmentVariablesJson","staticRequiredCertificatesJson","allowedMcpToolsJson"],"type":"object","properties":{"uniqueIdentifier":{"type":"string","format":"uuid"},"isListed":{"type":"boolean"},"version":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"isDeleted":{"type":"boolean"},"processVariablesJson":{"maxLength":2147483647,"type":["null","string"]},"processTags":{"maxLength":2147483647,"type":["null","string"]},"documentation":{"oneOf":[{"type":"null"},{"$ref":"#/components/schemas/ProcessDocumentation"}]},"getVersion":{"pattern":"^\\d+(\\.\\d+){1,3}$","type":["null","string"]},"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"majorVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"minorVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"name":{"maxLength":512,"minLength":0,"type":"string"},"modifier":{"maxLength":256,"minLength":0,"type":"string"},"modified":{"type":"string","format":"date-time"},"targetFramework":{"maxLength":32,"minLength":0,"type":"string"},"frendsVersion":{"maxLength":64,"minLength":0,"type":"string"},"isSubProcess":{"type":"boolean"},"staticRequiredEnvironmentVariablesJson":{"maxLength":2147483647,"type":"string"},"staticRequiredCertificatesJson":{"maxLength":2147483647,"type":"string"},"description":{"maxLength":2147483647,"minLength":0,"type":["null","string"]},"changeDescription":{"maxLength":2147483647,"minLength":0,"type":["null","string"]},"bpmn":{"maxLength":2147483647,"minLength":0,"type":["null","string"]},"isForMonitoringRule":{"type":["null","boolean"]},"cancellationDisabled":{"type":["null","boolean"]},"elementParameters":{"maxLength":2147483647,"minLength":0,"type":["null","string"]},"promotedResultVariablesJson":{"maxLength":2147483647,"minLength":0,"type":["null","string"]},"usedSubprocessesJson":{"maxLength":2147483647,"minLength":0,"type":["null","string"]},"usedTasksJson":{"maxLength":2147483647,"minLength":0,"type":["null","string"]},"triggersJson":{"maxLength":2147483647,"minLength":0,"type":["null","string"]},"manualTriggerJson":{"maxLength":2147483647,"minLength":0,"type":["null","string"]},"allowedMcpToolsJson":{"maxLength":2147483647,"minLength":0,"type":"string"},"preserveReferencesAtCheckpoint":{"type":"boolean"}}},"ProcessDocumentation":{"required":["uniqueIdentifier","documentationMarkdown","modifier","majorVersion","minorVersion"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"uniqueIdentifier":{"type":"string","format":"uuid"},"documentationMarkdown":{"maxLength":2147483647,"type":"string"},"modifier":{"maxLength":256,"type":"string"},"majorVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"minorVersion":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"modifiedUtc":{"type":"string","format":"date-time"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## Publish ("save") the active version of an API specification

> This locks down the current specification and process versions. A new active version is created, and the previous one becomes deployable.

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{id}/publish":{"post":{"tags":["ApiSpecifications"],"summary":"Publish (\"save\") the active version of an API specification","description":"This locks down the current specification and process versions. A new active version is created, and the previous one becomes deployable.","parameters":[{"name":"id","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"requestBody":{"description":"Publish API parameters","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PublishApiRequest"}}},"required":true},"responses":{"200":{"description":"OK"},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"409":{"description":"Conflict","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"PublishApiRequest":{"type":"object","properties":{"changeDescription":{"type":["null","string"],"description":"Description of the changes made"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## Begin deploying a version of an API specification to an Agent Group

> Returns information about the processes which must be deployed to finish the API deployment. The processes can be deployed using the process-deployments API.

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{id}/{apiVersion}/deploy/{agentGroupId}":{"post":{"tags":["ApiSpecifications"],"summary":"Begin deploying a version of an API specification to an Agent Group","description":"Returns information about the processes which must be deployed to finish the API deployment. The processes can be deployed using the process-deployments API.","parameters":[{"name":"id","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}},{"name":"apiVersion","in":"path","description":"API specification version","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int32"}},{"name":"agentGroupId","in":"path","description":"Agent Group identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK"},"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## GET /api/v1/api-management/api-specifications/{apiSpecificationId}/{apiVersion}/api-passthrough

> List API passthrough configurations

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{apiSpecificationId}/{apiVersion}/api-passthrough":{"get":{"tags":["ApiSpecifications"],"summary":"List API passthrough configurations","parameters":[{"name":"apiSpecificationId","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}},{"name":"apiVersion","in":"path","description":"API specification version","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int32"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseOfIListOfApiPassthroughViewModel"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ResponseOfIListOfApiPassthroughViewModel":{"required":["data"],"type":"object","properties":{"data":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPassthroughViewModel"},"description":"Response data"}}},"ApiPassthroughViewModel":{"required":["id","apiVersionId","modifier","modified","path","method","isDefault","corsEnabled","targetUrl","headers","allowedOrigins"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier of the passthrough configuration","format":"int64"},"apiVersionId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier of the API version","format":"int64"},"modifier":{"type":"string","description":"User who last modified the configuration"},"modified":{"type":"string","description":"Time when configuration was last modified","format":"date-time"},"path":{"type":["null","string"],"description":"Source API path for this passthrough configuration. Not used when IsDefault is set to true."},"method":{"type":["null","string"],"description":"HTTP method. Not used when IsDefault is set to true."},"isDefault":{"type":"boolean","description":"Is this configuration used for all paths and HTTP methods"},"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"description":"Target URL","$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions"},"allowedOrigins":{"type":["null","array"],"items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled."}}},"ApiPassthroughTarget":{"required":["server","basePath","operationPath","query"],"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":["null","string"],"description":"Operation path of the target URL"},"query":{"type":["null","string"],"description":"Query parameters of the target URL"}}},"ApiPassthroughHeader":{"required":["action","name","value"],"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## POST /api/v1/api-management/api-specifications/{apiSpecificationId}/{apiVersion}/api-passthrough

> Create API passthrough configuration

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{apiSpecificationId}/{apiVersion}/api-passthrough":{"post":{"tags":["ApiSpecifications"],"summary":"Create API passthrough configuration","parameters":[{"name":"apiSpecificationId","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}},{"name":"apiVersion","in":"path","description":"API specification version","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int32"}}],"requestBody":{"description":"API passhthrough configuration","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiPassthroughCreateModel"}}},"required":true},"responses":{"201":{"description":"Created"},"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"409":{"description":"Conflict","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ApiPassthroughCreateModel":{"required":["path","method","isDefault","corsEnabled","targetUrl","headers","allowedOrigins"],"type":"object","properties":{"path":{"type":["null","string"],"description":"Source API path for this passthrough configuration. Not used when IsDefault is set to true."},"method":{"type":["null","string"],"description":"HTTP method. Not used when IsDefault is set to true."},"isDefault":{"type":"boolean","description":"Is this configuration used for all paths and HTTP methods"},"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"description":"Target URL","$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions"},"allowedOrigins":{"type":["null","array"],"items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled."}}},"ApiPassthroughTarget":{"required":["server","basePath","operationPath","query"],"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":["null","string"],"description":"Operation path of the target URL"},"query":{"type":["null","string"],"description":"Query parameters of the target URL"}}},"ApiPassthroughHeader":{"required":["action","name","value"],"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## PUT /api/v1/api-management/api-specifications/{apiSpecificationId}/{apiVersion}/api-passthrough/{passthroughConfigId}

> Update API passthrough configuration

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{apiSpecificationId}/{apiVersion}/api-passthrough/{passthroughConfigId}":{"put":{"tags":["ApiSpecifications"],"summary":"Update API passthrough configuration","parameters":[{"name":"apiSpecificationId","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}},{"name":"apiVersion","in":"path","description":"API specification version","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int32"}},{"name":"passthroughConfigId","in":"path","description":"API passthrough configuration identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"requestBody":{"description":"The new configuration","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiPassthroughEditModel"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ResponseOfApiPassthroughViewModel"}}}},"400":{"description":"Bad Request","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ApiPassthroughEditModel":{"required":["corsEnabled","targetUrl","headers","allowedOrigins"],"type":"object","properties":{"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"description":"Target URL","$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions"},"allowedOrigins":{"type":["null","array"],"items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled."}}},"ApiPassthroughTarget":{"required":["server","basePath","operationPath","query"],"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":["null","string"],"description":"Operation path of the target URL"},"query":{"type":["null","string"],"description":"Query parameters of the target URL"}}},"ApiPassthroughHeader":{"required":["action","name","value"],"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}}},"ResponseOfApiPassthroughViewModel":{"required":["data"],"type":"object","properties":{"data":{"oneOf":[{"type":"null"},{"description":"Response data","$ref":"#/components/schemas/ApiPassthroughViewModel"}]}}},"ApiPassthroughViewModel":{"required":["id","apiVersionId","modifier","modified","path","method","isDefault","corsEnabled","targetUrl","headers","allowedOrigins"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier of the passthrough configuration","format":"int64"},"apiVersionId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier of the API version","format":"int64"},"modifier":{"type":"string","description":"User who last modified the configuration"},"modified":{"type":"string","description":"Time when configuration was last modified","format":"date-time"},"path":{"type":["null","string"],"description":"Source API path for this passthrough configuration. Not used when IsDefault is set to true."},"method":{"type":["null","string"],"description":"HTTP method. Not used when IsDefault is set to true."},"isDefault":{"type":"boolean","description":"Is this configuration used for all paths and HTTP methods"},"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"description":"Target URL","$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions"},"allowedOrigins":{"type":["null","array"],"items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled."}}},"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```

## DELETE /api/v1/api-management/api-specifications/{apiSpecificationId}/{apiVersion}/api-passthrough/{passthroughConfigId}

> Delete API passthrough configuration

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"tags":[{"name":"ApiSpecifications"}],"servers":[{"url":"https://example.v64.frendsapp.com/"}],"security":[{}],"paths":{"/api/v1/api-management/api-specifications/{apiSpecificationId}/{apiVersion}/api-passthrough/{passthroughConfigId}":{"delete":{"tags":["ApiSpecifications"],"summary":"Delete API passthrough configuration","parameters":[{"name":"apiSpecificationId","in":"path","description":"API specification identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}},{"name":"apiVersion","in":"path","description":"API specification version","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int32"}},{"name":"passthroughConfigId","in":"path","description":"API passthrough configuration identifier","required":true,"schema":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":"integer","format":"int64"}}],"responses":{"204":{"description":"No Content"},"404":{"description":"Not Found","content":{"application/problem+json":{"schema":{"$ref":"#/components/schemas/ProblemDetails"}}}}}}}},"components":{"schemas":{"ProblemDetails":{"type":"object","properties":{"type":{"type":["null","string"]},"title":{"type":["null","string"]},"status":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"detail":{"type":["null","string"]},"instance":{"type":["null","string"]}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.frends.com/reference/frends-platform-api/platform-api-reference/api-specifications.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
